<script setup lang="ts">
// import { title } from 'process'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Salary } from '@/types/Salary'

const headers = [
  {
    title: 'ID',
    key: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },
  {
    title: 'Role',
    key: 'roles',
    value: (item: any | Salary) => item.roles.join(',')
  },
  {
    title: 'Status',
    key: 'status',
    value: (item: any | Salary) => item.status.join(',')
  },
  {
    title: 'Payment Status',
    key: 'paymentStatus',
    value: 'paymentStatus'
  },
  {
    title: 'Salary',
    key: 'salary',
    value: 'salary'
  },
  { title: 'Pay', key: 'actions', sortable: false }
]

const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const initilSalary: Salary = {
  id: -1,
  name: '',
  tel: '',
  roles: ['Manager'],
  status: ['FullTime'],
  salary: 0,
  paymentStatus: ['Waiting for Payment']
}
const editedSalary = ref<Salary>(JSON.parse(JSON.stringify(initilSalary)))
const salary = ref<Salary[]>([])
let editedIndex = -1
let lastId = 6
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedSalary.value = Object.assign({}, initilSalary)
  })
}
function deleteItemConfirm() {
  // Delete item from list
  salary.value.splice(editedIndex, 1)
  closeDelete()
}
function editItem(item: Salary) {
  editedIndex = salary.value.indexOf(item)
  editedSalary.value = Object.assign({}, item)
  dialog.value = true
}
function deleteItem(item: Salary) {
  editedIndex = salary.value.indexOf(item)
  editedSalary.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}
function initialize() {
  salary.value = [
    {
      id: 1,
      name: 'Toge Inumaki',
      tel: '0891234508',
      roles: ['Manager'],
      status: ['PartTime', 'FullTime'],
      paymentStatus: ['Waiting for Payment'],
      salary: 30000
    },
    {
      id: 2,
      name: 'Anya Forger',
      tel: '0891234567',
      roles: ['Staff'],
      status: ['FullTime'],
      paymentStatus: ['Waiting for Payment'],
      salary: 15000
    },
    {
      id: 3,
      name: 'Levi Ackerman',
      tel: '0834567891',
      roles: ['Staff'],
      status: ['PartTime'],
      paymentStatus: ['Waiting for Payment'],
      salary: 15500
    },
    {
      id: 4,
      name: 'Tobio Kageyama',
      tel: '0871234589',
      roles: ['Staff'],
      status: ['FullTime'],
      paymentStatus: ['Waiting for Payment'],
      salary: 16000
    },
    {
      id: 5,
      name: 'Kiyoko Shimizu',
      tel: '0997851234',
      roles: ['Staff'],
      status: ['PartTime'],
      paymentStatus: ['Waiting for Payment'],
      salary: 18000
    }
  ]
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedSalary.value = Object.assign({}, initilSalary)
    editedIndex = -1
  })
}
async function pay() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(salary.value[editedIndex], editedSalary.value)
  }
  editedIndex = -1
  closeDialog()
}
onMounted(() => {
  initialize()
})
</script>

<template>
  <div>
    <v-data-table style="background-color: #efe7e1" :headers="headers" :items="salary">
      <template v-slot:top>
        <v-toolbar flat style="color: #f5f3ef; background-color: #8b7565">
          <v-toolbar-title>Salary Payment</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog-->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }"> </template>

            <v-card>
              <v-card-title>
                <span class="text-h5">Salary Payment</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-card-text>
                        <v-select
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Select"
                          :items="['KBANK', 'KTB', 'TTB', 'SCB', 'UOB', 'KKB']"
                        ></v-select>
                        <v-text-field
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Bank Account"
                        ></v-text-field>
                      </v-card-text>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="pay()"> Pay </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-btn size="small" color="#81322c" class="me-2" @click="editItem(item)"
          >Salary Payment</v-btn
        >
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="initialize"> Reset </v-btn>
      </template></v-data-table
    >
  </div>
</template>

<style>
.custom-button {
  margin: 5px;
  /* เว้นระยะห่าง */
  border-radius: 20px;
  /* make the roundness */
  padding: 10px 20px;
}
</style>
